%define name		carol
%define version		1.8.9.3
%define release		%mkrel 1.1
%define	section		free
%define gcj_support	1

Name:		%{name}
Summary:	CAROL: Common Architecture for RMI ObjectWeb Layer
Url:		http://carol.objectweb.org/
Version:	%{version}
Release:	%{release}
Epoch:		0
License:	LGPL
Group:		Development/Java
Source0:	carol-%{version}-src-RHCLEAN.tar.bz2
Patch0:		carol-%{version}-commons-cli.patch.bz2
Patch1:		%{name}-pr21949.patch.bz2
Patch2:		%{name}-sunclasses.patch.bz2
Patch3:		%{name}-bz133180.patch.bz2

BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:	ant >= 0:1.6
BuildRequires:  %{_bindir}/perl
BuildRequires:	objectweb-anttask
BuildRequires:  jakarta-commons-cli
BuildRequires:  jacorb
BuildRequires:  jgroups
BuildRequires:  jonathan-core >= 0:4.0
BuildRequires:  jonathan-jeremie >= 0:4.1
BuildRequires:  oldkilim
BuildRequires:  log4j
BuildRequires:  nanoxml-lite
BuildRequires:  monolog
BuildRequires:  velocity
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
BuildRequires:	jonathan-rmi >= 0:3.1
Requires:  jakarta-commons-cli
Requires:  jacorb
Requires:  jgroups
Requires:  jonathan-core >= 0:4.0
Requires:  jonathan-jeremie >= 0:4.1
Requires:  oldkilim
Requires:  log4j
Requires:  nanoxml-lite
Requires:  monolog
Requires:  velocity
Requires:  xerces-j2
Requires:  xml-commons-apis
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
# libgcj aot-compiled native libraries
%if %{gcj_support}
BuildRequires:    java-gcj-compat-devel >= 0:1.0.31
Requires(post):   java-gcj-compat >= 0:1.0.31
Requires(postun): java-gcj-compat >= 0:1.0.31
%endif

%description
CAROL is a library allowing to use different RMI implementations. 
Thanks to CAROL, a Java server application can be independent of 
RMI implementations and accessible simultaneously by RMI clients 
using different RMI implementations. CAROL allows to design, 
implement, compile, package, deploy, and execute distributed 
applications compliant with the RMI model.


%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Java

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{name}
chmod -R go=u-w *
find . -name "*.jar" -exec rm -f {} \;

%patch0 -b .sav
%patch1 -p1
%patch2 -p1
%patch3 -p1

# assume no filename contains spaces
perl -p -i -e 's/org(.)javagroups/org${1}jgroups/' `grep org.javagroups -lr *`

%build
pushd externals
ln -sf $(build-classpath commons-cli) .
ln -sf $(build-classpath jacorb/jacorb) .
ln -sf $(build-classpath jgroups) .
ln -sf $(build-classpath jonathan-core) .
ln -sf $(build-classpath jonathan-jeremie) .
ln -sf $(build-classpath oldkilim) .
ln -sf $(build-classpath oldkilim-tools) .
ln -sf $(build-classpath log4j) .
ln -sf $(build-classpath nanoxml-lite) .
ln -sf $(build-classpath monolog/ow_util_log_file) .
ln -sf $(build-classpath monolog/ow_util_log_wrp_log4j) .
ln -sf $(build-classpath velocity) .
ln -sf $(build-classpath xerces-j2) .
ln -sf $(build-classpath xml-commons-apis) .
popd

export OPT_JAR_LIST="objectweb-anttask"
%ant dist jdoc

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 output/dist/lib/ow_%{name}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/ow_%{name}-%{version}.jar
install -m 644 output/dist/lib/ow_%{name}_core.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/ow_%{name}-%{version}_core.jar
install -m 644 output/dist/lib/ow_%{name}_cmic.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/ow_%{name}-%{version}_cmic.jar
install -m 644 output/dist/lib/cmic.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/cmic-%{version}.jar
install -m 644 output/dist/lib/daemon.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/daemon-%{version}.jar
install -m 644 output/dist/lib/shell.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/shell-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr output/dist/jdoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
%{_jvmdir}/java-gcj/bin/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{gcj_support}
%post
%{_bindir}/rebuild-gcj-db

%postun
%{_bindir}/rebuild-gcj-db
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(-,root,root)
%{_javadir}/%{name}
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}
%endif

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Mon Sep 12 2005 David Walluck <walluck@mandriva.org> 0:1.8.9.3-1.1mdk
- release

* Mon Aug  1 2005 Gary Benson <gbenson at redhat.com> 0:1.8.9.3-1jpp_5fc
- Remove explicit references to jacorb and jonathan-rmi.
- Switch to aot-compile-rpm.
- Build on ia64, ppc64, s390 and s390x.

* Mon Jun 27 2005 Gary Benson <gbenson at redhat.com> 0:1.8.9.3-1jpp_4fc
- 'And do it again until you get it right!'

* Mon Jun 27 2005 Gary Benson <gbenson at redhat.com> 0:1.8.9.3-1jpp_3fc
- Build the gcj classmap correctly.

* Mon Jun 27 2005 Gary Benson <gbenson at redhat.com> 0:1.8.9.3-1jpp_2fc
- BC-compile the combined jarfile.

* Fri Jun 17 2005 Gary Benson <gbenson at redhat.com> 0:1.8.9.3-1jpp_1fc
- Build into Fedora.

* Thu Jun  9 2005 Gary Benson <gbenson at redhat.com>
- Remove jarfiles from the tarball.

* Wed Jun  8 2005 Gary Benson <gbenson at redhat.com>
- Pick up javax.rmi classes from jonathan-rmi.
- Work around PR libgcj/21949.
- Avoid Sun-specific classes.
- Avoid around GNU rmic failure (#133180).

* Mon Mar 07 2005 Fernando Nasser <fnasser at redhat.com> 0:1.8.9.3-1jpp_1rh
- Upgrade to 1.8.9.3

* Fri Mar 04 2005 Fernando Nasser <fnasser at redhat.com> 0:1.8.9.2-1jpp_2rh
- Backport patch so that registry will also start iiop NameServers

* Tue Mar 01 2005 Fernando Nasser <fnasser at redhat.com> 0:1.8.9.2-1jpp_1rh
- Upgrade to 1.8.9.2
- Rebuild with BEA

* Tue Jan 11 2005 Fernando Nasser <fnasser at redhat.com> 0:1.8.9-1jpp_1rh
- Merge with upstream for upgrade

* Mon Jan 10 2005 Fernando Nasser <fnasser at redhat.com> 0:1.8.9-1jpp
- Upgrade to 1.8.9

* Mon Dec 20 2004 Fernando Nasser <fnasser at redhat.com> 0:1.8.4-1jpp_1rh
- First Red Hat release

* Mon Dec 20 2004 Fernando Nasser <fnasser at redhat.com> 0:1.8.4-1jpp
- Upgrade to 1.8.4

* Mon Oct 04 2004 Ralph Apel <r.apel at r-apel.de> 0:1.5.1-1jpp
- First release

